unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, XPMan, Registry;

type
  TCF = class(TForm)
    LabeledEdit1: TLabeledEdit;
    Memo1: TMemo;
    Label1: TLabel;
    LabeledEdit2: TLabeledEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    XPManifest1: TXPManifest;
    SaveDialog1: TSaveDialog;
    procedure LabeledEdit1DblClick(Sender: TObject);
    procedure LabeledEdit2DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CF: TCF;
  comline : String;
  si : Tstartupinfo;
  p : Tprocessinformation;

implementation

{$R *.dfm}

procedure TCF.LabeledEdit1DblClick(Sender: TObject);
begin
OpenDialog1.InitialDir := ExtractFileDir (Application.ExeName);
if OpenDialog1.Execute then
 Begin
  Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
  LabeledEdit1.Text := OpenDialog1.FileName;
 End;
end;

procedure TCF.LabeledEdit2DblClick(Sender: TObject);
begin
SaveDialog1.InitialDir := ExtractFileDir (Application.ExeName);
if SaveDialog1.Execute then
 LabeledEdit2.Text := SaveDialog1.FileName;
 if ExtractFileExt (SaveDialog1.FileName) = '' then
  LabeledEdit2.Text := SaveDialog1.FileName+'.exe';
end;

  procedure ExportData(Path, AName, AType: String; Data: TFileStream); overload;
  var
    hFile: HWND;
    Buf: array of Byte;
  begin
    hFile := BeginUpdateResource(PChar(Path), False);
    try
      if hFile = 0 then
      begin
        RaiseLastOSError;
      end;
      SetLength(Buf, Data.Size);
      Data.Position := 0;
      Data.Read(Buf[0], Data.Size);
      if not UpdateResource(hFile, PChar(AType), PChar(AName),
        0, @Buf[0], Data.Size) then RaiseLastOSError;    
      Finalize(Buf);
    finally
      EndUpdateResource(hFile, False);
    end;
  end;

procedure Delay(msecs:integer);
var
FirstTickCount:longint;
begin
FirstTickCount:=GetTickCount;
repeat
Application.ProcessMessages;
until ((GetTickCount-FirstTickCount) >= msecs);
end;


procedure TCF.Button1Click(Sender: TObject);
Var
 Data : TFileStream;
 temp : String;
 REg : TRegistry;
 Res : TResourceStream;
 
begin

//---- temp path Begin
reg := Tregistry.Create;
 try
  reg.RootKey:= HKEY_CURRENT_USER;
  if reg.OpenKey ('Environment',false) then
  begin
   temp := reg.readString('TEMP');
  end;
 finally
reg.Free;
End;
//---- temp path End
Memo1.Lines.SaveToFile(temp+'\~rr.txt');
Res:=TResourceStream.Create(Hinstance,'rrexec','data');
Res.SavetoFile(temp+'\RRes.exe');
Res.Free;
Res:=TResourceStream.Create(Hinstance,'upx','data');
Res.SavetoFile(temp+'\upx.exe');
Res.Free;

Delay (100);
Data := TFileStream.Create(temp+'\~rr.txt', fmOpenRead);
try
 ExportData(temp+'\RRes.exe', 'RUNRES', 'DATA', Data);
finally
Data.Free;
end;

//------ UPX
comline := temp+'\upx.exe -9 '+temp+'\RRes.exe';
fillChar( Si, SizeOf( Si ) , 0 );
with Si do
 begin
  cb := SizeOf( Si);
  dwFlags := startf_UseShowWindow;
  wShowWindow := SW_Hide; {0 ////4}
 end;             //  ShellExecute

 Createprocess(nil,pChar(comLine),nil,nil,false,Create_default_error_mode,nil,nil,si,p);
//Application.ProcessMessages;
 Waitforsingleobject(p.hProcess,infinite);

///----- UPX

if FileExists (LabeledEdit2.Text) then
 DeleteFile (LabeledEdit2.Text);
RenameFile (temp+'\RREs.exe',LabeledEdit2.Text);
if FileExists (LabeledEdit2.Text) then
 Begin
  DeleteFile (temp+'\~rr.txt');
  DeleteFile (temp+'\upx.exe');
 End;  
 
end;

end.
